#########################################################################################################
# NB: per eseguire questo script  necessario:								#
#	1. Modificare l'estensione del file in ".ps1"							#
#	2. Abilitare l'esecuzione degli script PowerShell (PS):						#
#		- Eseguire una istanza di PS								#
#		- Eseguire il comando seguente:								#
#			Set-ExecutionPolicy RemoteSigned						#
# Oppure - per non modificare la policy di esecuzione degli script PS attuale -  possibile eseguire	#
# eseguire lo script aprendo un prompt di comando (cmd.exe) ed eseguendo il comando seguente (nel quale #
# si assume che il file sia stato salvato nella directory c:\temp):					#
#													#
# powershell.exe -NoLogo -NoProfile -executionpolicy ByPass -command c:\temp\Set-DefaultPrinter.ps1	#
#													#
# In questo modo viene modificata la policy di esecuzione solo per l'istanza corrente di PS ma non 	#
# quella di default (salvata a livello di registry).							#
#########################################################################################################
#Definizione Variabili Globali
$num_arg = $args.count
$printers = Get-WmiObject Win32_Printer
$totalPrinters = $printers.count

#Definizione funzioni

function Show-Default-Printer() {
	for ($i=0; $i -lt $printers.count; $i++) { if ($printers[$i].Default) { $ndefaultPrinter = $i; $defaultPrinter = $printers[$i]} }
	"===`nIn questo momento la stampante di default  la seguente: `$printers[{0}] = {1}`n===" -f $ndefaultPrinter, $defaultPrinter.Name
}

function Get-Stampanti() {
	"Scegli una tra le seguenti stampanti disponibili:"
	for ($p = 0; $p -lt $totalPrinters; $p++) {
		"===`nStampante Numero: {0:d}`n{1}" -f $p, $printers[$p].Name
	}
}

function Seleziona-Stampante() {
	[int]$numStampante = Read-Host -Prompt "Inserisci il numero della stampante ($totalPrinters = Quit)"
	if ( ($numStampante -lt 0) -or ($numStampante -gt $totalPrinters) ) {
		"Hai inserito un numero errato !!!"
		Seleziona-Stampante
	} elseif ($numStampante -eq $totalPrinters) {
		exit		
	} else {
		$stampante = $printers[$numStampante].Name
		$a = Get-WMIObject -query "Select * From Win32_Printer Where Name = '$stampante'"
		$a.SetDefaultPrinter()
	}
}

Function Usage() {
#Inizializzazione "Here-String"
$errorMsg = @"
	`n`tErrore: sono stati passati $num_arg argomenti anzich uno !!!
	`tUsage: .\Set-DefaultPrinter.ps1 <Nome Stampante>`n
	Comunque non ti preoccupare, vado avanti lo stesso e - se vuoi - ti aiuto a
	scegliere una stampante di default tra quelle attualmente presenti.
"@

$errorMsg
}


#Fine definizione funzioni

#Inizio main()
"=========================================================="
"Script PowerShell per la scelta della stampante di default"
"=========================================================="
if ($num_arg -ne 1) {
	Usage
	Show-Default-Printer
	Get-Stampanti
	Seleziona-Stampante
} else {
	$stampante = $args[0]
	$a = Get-WMIObject -query "Select * From Win32_Printer Where Name = '$stampante'"
	$a.SetDefaultPrinter()
}
